* PACKAGE DDIAG  !" ϳإʥ : ǽ
*
*"  [HIS]  99/12/07(takepiro)
*
***********************************************************************
      SUBROUTINE MIDIAG      !"  ǽ 
     I         ( IT    , 
     I           GDU   , GDV   , GDW   , GDT   , 
     I           GBLON , GBLAT , GBRAD , 
     C           PRND  , RAYL  , 
     C           ALON  , DLON  , ALAT  , DLAT  , 
     C           ARAD  , DRAD                    )
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ɸʪ
*
*   [INPUT]
      INTEGER    IT                          !" ̤
*
      REAL       GDU   ( IDIM, JDIM, KDIM )  !"   
      REAL       GDV   ( IDIM, JDIM, KDIM )  !"   
      REAL       GDW   ( IDIM, JDIM, KDIM )  !" ľ 
      REAL       GDT   ( IDIM, JDIM, KDIM )  !"   
*
      REAL       GBLON  ( IDIM, JDIM, 0:KMAX )  !" ʬ
      REAL       GBLAT  ( IDIM, JDIM, 0:KMAX )  !" ʬ
      REAL       GBRAD  ( IDIM, JDIM, 0:KMAX )  !" ưʬ
*
      REAL       RAYL                        !" 쥤꡼
      REAL       PRND                        !" ץɥ
*
      REAL       ALON  ( IDIM )               !" 
      REAL       DLON  ( IDIM )               !" ٲٽ
      REAL       ALAT  ( JDIM )               !" 
      REAL       DLAT  ( JDIM )               !" ٲٽ
      REAL       ARAD  ( KDIM )               !" ٥()
      REAL       DRAD  ( KDIM )               !" ()
*
*   [INTERNAL WORK]
      REAL       GDKE    !" ưͥ륮
      REAL       GDIE    !" ͥ륮
      REAL       GDME    !" 쥨ͥ륮
      REAL       GDTE    !" ͥ륮
      REAL       GDAM    !" ѱư
*      
      CHARACTER HEADKE(NDC)*(NCC) !" GTOOL3 إå(ưͥ륮)
      CHARACTER HEADIE(NDC)*(NCC) !" GTOOL3 إå(ͥ륮)
      CHARACTER HEADME(NDC)*(NCC) !" GTOOL3 إå(쥨ͥ륮ʬ)
      CHARACTER HEADTE(NDC)*(NCC) !" GTOOL3 إå(ͥ륮)
      CHARACTER HEADAM(NDC)*(NCC) !" GTOOL3 إå(ѱư)
*
      INTEGER   IERR            !" 顼եå
      INTEGER   IFILED          !" ǥեֹ
      CHARACTER HACT*(NCC)      !" ư(ɤ/)
      CHARACTER HFORM*(NCC)     !" Ͻ
*     
      INTEGER   IFNM, JFNM      !" NAMELIST ֹ
*
* [INTERNAL SAVE]
      INTEGER   JFILE           !" ֹ
      INTEGER   MODE            !" ϥ⡼(1 ITEM,TIMEɽ)
      INTEGER   NOEND           !" END OF FILE ν(0 ǹԤʤ)
      LOGICAL   OFIRST
*
* [NAMELIST]
      CHARACTER FILE*(NFILN)    !" ꥹȽϥե
      CHARACTER DFMT*(NCC)      !" ǡ
      INTEGER   INTOUT          !" ϴֳ
*
* [NAMELIST DEFAULT]
      NAMELIST /NMDIAG/  FILE , DFMT , INTOUT
      DATA      FILE ,        DFMT ,  INTOUT
     &         /'gamhd.DIAG', 'UR4',  -1   /
*
      DATA      IFILED,    HACT,     HFORM 
     &         /   50,  'WRITE', 'UNFORMATTED' /
      DATA      MODE, NOEND
     &         /   1,    0 /
      DATA      OFIRST   /.TRUE./
*
      SAVE  JFILE, MODE, NOEND, OFIRST, DFMT, INTOUT
*
*"               < 1. NAMELIST ɤߤȤ, ե륪ץ >
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL REWNML ( IFNM, JFNM )
         READ  ( IFNM, NMDIAG , END=1190 )
 1190    WRITE ( JFNM, NMDIAG )
*
         CALL GFOPEN
     O      ( JFILE , IERR ,
     I         FILE , IFILED , HACT , HFORM )
      ENDIF
*
      IF ( INTOUT .GT. 0 ) THEN
         IF ( MOD(IT, INTOUT ) .EQ. 0 ) THEN
*
*"               < 2. إå >
*
            CALL IHDST0         !" إå
     O           ( HEADKE, 
     I             'KE'  , 'kinematic energy' , 
     I             IT    ,  DFMT               )
            CALL MIPARM 
     M           ( HEADKE )
*
            CALL IHDST0         !" إå
     O           ( HEADIE, 
     I             'IE'  , 'potential energy' , 
     I             IT    ,  DFMT               )
            CALL MIPARM 
     M           ( HEADIE )
*
            CALL IHDST0         !" إå
     O           ( HEADME, 
     I             'ME'  , 'magnetic energy' , 
     I             IT    ,  DFMT               )
            CALL MIPARM 
     M           ( HEADME )
*
            CALL IHDST0         !" إå
     O           ( HEADTE, 
     I             'TE'  , 'total energy' , 
     I             IT    ,  DFMT               )
            CALL MIPARM 
     M           ( HEADTE )
*
            CALL IHDST0         !" إå
     O           ( HEADAM, 
     I             'AM'  , 'angular monentum' , 
     I             IT    ,  DFMT               )
            CALL MIPARM 
     M           ( HEADAM )
*
*"               < 3. ¸̷׻ >
*
            CALL DDIAG          !"  ǽ 
     O         ( GDKE  , GDIE  , GDTE  , GDAM  ,
     I           GDU   , GDV   , GDW   , GDT   , 
     C           PRND  , RAYL  , 
     C           ALON  , DLON  , ALAT  , DLAT  , 
     C           ARAD  , DRAD                    )
*
            CALL KDDIAG         !"  ǽ 
     O           ( GDME  ,
     I             GBLON , GBLAT , GBRAD , 
     C             ALON  , DLON  , ALAT  , DLAT  , 
     C             ARAD  , DRAD                    )
*
            GDTE = GDTE + GDME
*
*"               < 4.  >
*
            CALL ZFWRIT         !" ưб롼
     I           ( HEADKE, GDKE    , 
     O             JFILE , MODE   , NOEND )
            CALL ZFWRIT         !" ưб롼
     I           ( HEADIE, GDIE    , 
     O             JFILE , MODE   , NOEND )
            CALL ZFWRIT         !" ưб롼
     I           ( HEADME, GDME    , 
     O             JFILE , MODE   , NOEND )
            CALL ZFWRIT         !" ưб롼
     I           ( HEADTE, GDTE    , 
     O             JFILE , MODE   , NOEND )
            CALL ZFWRIT         !" ưб롼
     I           ( HEADAM, GDAM    , 
     O             JFILE , MODE   , NOEND )
         ENDIF
      ENDIF
*
      RETURN
      END
