*" PACKAGE GAMKYN !" ϳإʥ ᥤ롼
*"                  ver 1.00             99/12/02 takepiro
***********************************************************************
      PROGRAM GAMMHD                         !" ᥤ롼
*
*"    Boussinesq 屿ưŪʥǥ
*"      one-level time integration
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
*
*   [VAR]
      REAL       GDU   ( IDIM, JDIM, 0:KMAX )  !" ® u
      REAL       GDV   ( IDIM, JDIM, 0:KMAX )  !" ® v
      REAL       GDW   ( IDIM, JDIM, 0:KMAX )  !" ® w
      REAL       GDTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
      REAL       GDPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*
      REAL       GDT   ( IDIM, JDIM, 0:KMAX )  !"    
*
      REAL       GBLON ( IDIM, JDIM, 0:KMAX )  !" ʬ
      REAL       GBLAT ( IDIM, JDIM, 0:KMAX )  !" ʬ
      REAL       GBRAD ( IDIM, JDIM, 0:KMAX )  !" ưʬ
      REAL       GBTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ뼧 B_T
      REAL       GBPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ뼧 B_P
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       ERI                          !" 
*     REAL       ERO                          !" 
*     REAL       ETA                          !" /
*"    COMMON /COMCON/ end
*"       : ʪѥ᡼
*
*"       : ɸ
      REAL       ALAT  ( JDIM )        !" 
      REAL       DLAT  ( JDIM )        !" ٲٽ
      REAL       ALON  ( IDIM )        !" 
      REAL       DLON  ( IDIM )        !" ٲٽ
      REAL       ARAD  ( 0:KMAX )      !" ٥()
      REAL       DRAD  ( 0:KMAX )      !" ()
*
*"       : ֥ƥåץѥ᡼
      INTEGER    IT             !" 롼ץ
      CHARACTER  HINTG * (NCC)  !" ʬå
      LOGICAL    OOUT           !" ϥå
      LOGICAL    OEND           !" λå
      INTEGER    IUNIT          !" åֹ
      REAL       DELT           !" ֹ
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )       !" ΰ
*
*
*" << SETPUP :  >>
*
      CALL GLPGET( 'MSGUNIT', IUNIT )
      WRITE ( IUNIT, * ) ' 3-DIM MHD DYNAMO MODEL GAMMHD'
     &                   //NAME
     &                   //' ver.1.0, 99/12/02'
*
      CALL CLCSTR ( 'SETUP' )
      CALL YPREP                       !" ƥ 
*
      CALL ATSTRT                      !" ¸()
     O     ( IT , DELT ) 
*
      CALL ACRGET                      !" ɸ
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           ARAD  , DRAD   )
*
      CALL IHSTRT                      !" Ϥ
*
      CALL MIRRST                      !" ͤɤ߹ߤȺ
     O     ( GDU   , GDV   , GDW   , GDT   , GDTOR , GDPOR ,
     O       GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I       IT    ,
     C       ALAT  , DLAT  , ARAD  , DRAD             )
*
      CALL ADMXMN 
     I         ( GDU   , GDV   , GDW   , GDT   , 
     I           GDTOR , GDPOR ,
     I           GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I           IT  , 'start GA' )
*
      CALL CLCEND ( 'SETUP' )
*
*  << LOOP : <************* ᥤ󡦥롼 >>
*
 8888 CONTINUE
*
#ifdef DEBUG
      CALL ADMXMN 
     I         ( GDU   , GDV   , GDW   , GDT   , 
     I           GDTOR , GDPOR ,
     I           GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I           IT  , 'Loop' )
#endif
c$$$         ISTEP = ISTEP + 1
*
*     << START : ƥåפϤν >>
*
         CALL CLCSTR ( 'TIMCON' )
*
*"        < 1. ֥ƥå >
*
          CALL ATSTEP               !"   
     M         ( IT   ,     
     O           HINTG , OOUT , OEND )
*
         CALL CLCEND ( 'TIMCON' )
*
*"    << INTEGR : ʬ >>
* 
         CALL CLCSTR ( 'DYNMCS' )
*
         CALL MHADMN                             !" ϳŪʥ
     M         ( GDU   , GDV   , GDW   , GDT   , 
     M           GDTOR , GDPOR ,
     M           GBLON , GBLAT , GBRAD , 
     M           GBTOR , GBPOR , 
     I           IT    , DELT  , 
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
         CALL CLCEND ( 'DYNMCS' )
*
#ifdef DEBUG
*
         CALL ADMXMN 
     I         ( GDU   , GDV   , GDW   , GDT   , 
     I           GDTOR , GDPOR ,
     I           GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I           IT  , 'start GA' )
         CALL MIWRST                       !" ꥹȥե񤭹
     I         ( GDU   , GDV   , GDW   , GDT   , GDTOR , GDPOR ,
     I           GBLON , GBLAT , GBRAD , GBTOR , GBPOR , IT      )
#endif
*
*"    << NEXT : Υƥåפ >>
*
         CALL CLCSTR ( 'MISC' )
*
         IF ( OOUT ) THEN
            CALL MIWRST                    !" ꥹȥե񤭹
     I         ( GDU   , GDV   , GDW   , GDT   , GDTOR , GDPOR ,
     I           GBLON , GBLAT , GBRAD , GBTOR , GBPOR , IT      )
         ENDIF
*
         CALL CLCEND ( 'MISC' )
*
*" << LEND : ᥤ󡦥롼׽ *************> >>
*
      IF ( .NOT. OEND ) GOTO 8888    !" << LEND : ᥤ󡦥롼׽ ****> >>
*
      CALL ADMXMN 
     I         ( GDU   , GDV   , GDW   , GDT   , 
     I           GDTOR , GDPOR ,
     I           GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I           IT  , 'end GA' )

      CALL IHEND                       !" Ϥκǽ
*
      CALL CLCOUT                      !" CPUֽ
      CALL YFINE                       !" ƥ
*
      STOP
      END
*************************************************************************
      SUBROUTINE ADMXMN        !" debug monitor
     I         ( GDU   , GDV   , GDW   , GDT   , 
     I           GDTOR , GDPOR ,
     I           GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I           IT  , HLABEL  )
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
*
*   [INPUT] 
      REAL       GDU   ( IDIM, JDIM, KDIM )  !"    
      REAL       GDV   ( IDIM, JDIM, KDIM )  !"    
      REAL       GDW   ( IDIM, JDIM, KDIM )  !" ľ 
      REAL       GDT   ( IDIM, JDIM, KDIM )  !"    
      REAL       GDTOR ( IDIM, JDIM, KDIM )  !" ȥ 
      REAL       GDPOR ( IDIM, JDIM, KDIM )  !" ݥ 
*
      REAL       GBLON ( IDIM, JDIM, KDIM )  !" ʬ
      REAL       GBLAT ( IDIM, JDIM, KDIM )  !" ʬ
      REAL       GBRAD ( IDIM, JDIM, KDIM )  !" ưʬ
      REAL       GBTOR ( IDIM, JDIM, KDIM )  !" ȥ뼧 B_T
      REAL       GBPOR ( IDIM, JDIM, KDIM )  !" ݥ뼧 B_P
*
      INTEGER    IT
      CHARACTER  HLABEL *(*)
*
      WRITE ( 6,* ) HLABEL, ' IT= ', IT
      CALL MAXMIN( GDU,   IDIM, JDIM, KDIM, IDIM, JDIM, 'U'   )
      CALL MAXMIN( GDV,   IDIM, JDIM, KDIM, IDIM, JDIM, 'V'   )
      CALL MAXMIN( GDW,   IDIM, JDIM, KDIM, IDIM, JDIM, 'W'   )
      CALL MAXMIN( GDT,   IDIM, JDIM, KDIM, IDIM, JDIM, 'T'   )
      CALL MAXMIN( GDTOR, IDIM, JDIM, KDIM, IDIM, JDIM, 'TOR' )
      CALL MAXMIN( GDPOR, IDIM, JDIM, KDIM, IDIM, JDIM, 'POR' )
*
      CALL MAXMIN( GBLON, IDIM, JDIM, KDIM, IDIM, JDIM, 'BLON' )
      CALL MAXMIN( GBLAT, IDIM, JDIM, KDIM, IDIM, JDIM, 'BLAT' )
      CALL MAXMIN( GBRAD, IDIM, JDIM, KDIM, IDIM, JDIM, 'BRAD' )
      CALL MAXMIN( GBTOR, IDIM, JDIM, KDIM, IDIM, JDIM, 'BTOR' )
      CALL MAXMIN( GBPOR, IDIM, JDIM, KDIM, IDIM, JDIM, 'BPOR' )
*
      RETURN
      END
