* PACKAGE KDINTG  !" ưŪʥ : ʬ
*
*"   [HIS] 99/11/26(takepiro)
*
***********************************************************************
      SUBROUTINE KDTINT         !" ʬ ( ڥȥ )
     M         ( WDBTOR , WDBPOR , 
     I           WTBTOR , WTBPOR , 
     I           DELT   , ITRUNG , 
     C           FLAPLA , NMO    , 
     C           ARAD   , DRAD     )
*
*"                   4-th order Runge-Kutta scheme
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" ʻȿ
*
*   [MODIFY] 
      REAL       WDBTOR ( NMDIM , 0:KMAX     )  !" ȥ뼧 B_T
      REAL       WDBPOR ( NMDIM , 0:KMAX     )  !" ݥ뼧 B_P
*
*   [INPUT] 
      REAL       WTBTOR ( NMDIM, 0:KMAX      )  !" ȥ뼧 B_T
      REAL       WTBPOR ( NMDIM, 0:KMAX      )  !" ݥ뼧 B_P
*
      INTEGER    ITRUNG                        !" Runge-Kutta ѿ
      REAL       DELT                          !" ֹߦt
*
      REAL       FLAPLA( NMDIM  )              !" ץ饷η
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX )   !" ڥȥź
*
      REAL       ARAD  ( 0:KMAX )              !" ٥()
      REAL       DRAD  ( 0:KMAX )              !" ()
*
*   [INTERNAL WORK] 
      REAL       WDBTR0( NMDIM , 0:KMAX     )  !" ȥ뼧
      REAL       WDBPOR0( NMDIM , 0:KMAX     )  !" ݥ뼧
*"       : Τͤ򥻡 
*
      REAL       WDBTR1( NMDIM , 0:KMAX     )  !" ȥ뼧
      REAL       WDBPR1( NMDIM , 0:KMAX     )  !" ݥ뼧
*"       : ͤĤ߽Ťͤ
*
      REAL       DELTA1, DELTA2, DELTA3
      REAL       WEIGH1, WEIGH2, WEIGH3, WEIGH4
      INTEGER    NM, K
*
*"         < 0.  >
*
      IF ( ITRUNG . EQ. 1 ) THEN
         DELTA1  =  DELT * 0.5
         DELTA2  =  DELT * 0.5
         DELTA3  =  DELT
*
         WEIGH1  =       DELT / 6.
         WEIGH2  =  2. * DELT / 6. 
         WEIGH3  =  2. * DELT / 6. 
         WEIGH4  =       DELT / 6. 
*
         CALL COPY ( WDBTR0, WDBTOR , NMDIM*KDIM )
         CALL COPY ( WDBPOR0, WDBPOR , NMDIM*KDIM )
         CALL COPY ( WDBTR1, WDBTOR , NMDIM*KDIM )
         CALL COPY ( WDBPR1, WDBPOR , NMDIM*KDIM )
      ENDIF
*
*"         < 1. ʬ >
*
*
      IF ( ITRUNG . EQ. 1 )THEN
         DO 1100 K = 0 , KMAX
            DO 1100 NM = 1 , NMDIM
*"    < ȥ > 
               WDBTOR ( NM,K ) = WDBTR0( NM,K )
     &                     + WTBTOR ( NM,K )* DELTA1
               WDBTR1( NM,K ) = WDBTR1( NM,K )
     &                     + WTBTOR ( NM,K )* WEIGH1
*"    < ݥ >
               WDBPOR ( NM,K ) = WDBPOR0 ( NM,K )
     &                     + WTBPOR ( NM,K )* DELTA1
               WDBPR1 ( NM,K ) = WDBPR1 ( NM,K )
     &                     + WTBPOR ( NM,K )* WEIGH1
 1100    CONTINUE
*
      ELSE IF ( ITRUNG . EQ. 2 )THEN
         DO 1200 K = 0 , KMAX
            DO 1200 NM = 1 , NMDIM
*"    < ȥ > 
               WDBTOR ( NM,K ) = WDBTR0( NM,K )
     &                     + WTBTOR ( NM,K )* DELTA2
               WDBTR1( NM,K ) = WDBTR1( NM,K )
     &                     + WTBTOR ( NM,K )* WEIGH2
*"    < ݥ >
               WDBPOR ( NM,K ) = WDBPOR0 ( NM,K )
     &                     + WTBPOR ( NM,K )* DELTA2
               WDBPR1 ( NM,K ) = WDBPR1 ( NM,K )
     &                     + WTBPOR ( NM,K )* WEIGH2
 1200    CONTINUE
*
      ELSE IF ( ITRUNG . EQ. 3 )THEN
         DO 1300 K = 0 , KMAX
            DO 1300 NM = 1 , NMDIM
*"    < ȥ > 
               WDBTOR ( NM,K ) = WDBTR0( NM,K )
     &                     + WTBTOR ( NM,K )* DELTA3
               WDBTR1( NM,K ) = WDBTR1( NM,K )
     &                     + WTBTOR ( NM,K )* WEIGH3
*"    < ݥ >
               WDBPOR ( NM,K ) = WDBPOR0 ( NM,K )
     &                     + WTBPOR ( NM,K )* DELTA3
               WDBPR1 ( NM,K ) = WDBPR1 ( NM,K )
     &                     + WTBPOR ( NM,K )* WEIGH3
 1300    CONTINUE
*
      ELSE IF ( ITRUNG . EQ. 4 ) THEN
         DO 1400 K = 0, KMAX
            DO 1400 NM = 1, NMDIM
*"    < ȥ >
               WDBTOR( NM,K ) = WDBTR1( NM,K )
     &                     + WTBTOR ( NM,K )* WEIGH4
*"    < ݥ > 
               WDBPOR ( NM,K ) = WDBPR1 ( NM,K )
     &                     + WTBPOR ( NM,K )* WEIGH4
 1400    CONTINUE
      ELSE
         CALL MSGDMP ( 'E', 'TINTGR', 
     &                 'THE ORDER OF RUNGE-KUTTA SCHEME INVALID' )
      ENDIF
*
*"         < 2.  >
*
      CALL KDBNDR
     M       ( WDBTOR , WDBPOR , 
     C         NMO    ,
     C         ARAD   , DRAD    )
*
      RETURN
      END
